Redmine - Patch #22898

!>image.png! generates invalid HTML
2016-05-25 13:13 - Gregor Schmidt

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Jean-Philippe Lang % Done: 90%
Category: Text formatting Estimated time: 0.00 hour
Target version: 3.2.3

Description

Redmine's RedCloth (current trunk r15425) generates the following HTML:
Input: I>test.png! Paragraph with floating image
Output: <p><div style="float:right"><img src="test.png" alt="" /></div> Paragraph with floating image</p>

The div within the p is not allowed, therefore HTML parsers will autoclose the p, the div becomes a sibling to it, the text content will
become another sibling and the closing p will trigger another empty p element.

This is what's generated in Firefox's DOM: <p></p><div style="float:right"><img src="test.png" alt=""/> Paragraph with floating
image<p></p>.

The attached patch simply adds a span instead of a div and therefore generates the expected DOM structure.

Related issues:
Blocks Redmine - Feature #22923: Export Wiki to ODT New

Associated revisions

Revision 15442 - 2016-06-04 09:31 - Jean-Philippe Lang
Fix HTML generated for floating images in paragraphs (#22898).

Patch by Gregor Schmidt.

Revision 15444 - 2016-06-04 11:56 - Jean-Philippe Lang
Merged r15442 (#22898).

Revision 15445 - 2016-06-04 11:56 - Jean-Philippe Lang
Merged r15442 (#22898).

History

#1 - 2016-05-25 13:14 - Gregor Schmidt
- File 0001-Fix-HTML-generated-for-floating-images-in-paragraphs.patch added

#2 - 2016-05-26 04:35 - Anonymous
- File t_icon_fighter_skill5.png added

#3 - 2016-05-28 11:49 - Go MAEDA
- File deleted (t_icon_fighter_skill5.png)

#4 - 2016-05-30 12:51 - Jan from Planio www.plan.io
- Blocks Feature #22923: Export Wiki to ODT added

#5 - 2016-05-30 12:51 - Jan from Planio www.plan.io
- Target version set to Candidate for next minor release

- % Done changed from 0 to 90

#6 - 2016-06-03 02:19 - Go MAEDA
https://www.redmine.org/projects/redmine/repository/svn/revisions/15425

- File firebug-output.png added

- Target version changed from Candidate for next minor release to 3.3.0

Confirmed the problem. Firebug reports the DOM like the following. We can see "<p> </p>".

<p> </p>
WV «div style="float:right">

<img alt="" src="/attachments/download/51/test.png">
</div>

Paragraph with floating image
<p> </p>

Setting target version to 3.3.0.

#7 - 2016-06-04 09:31 - Jean-Philippe Lang
- Target version changed from 3.3.0 to 3.2.3

#8 - 2016-06-04 11:57 - Jean-Philippe Lang
- Status changed from New to Closed

- Assignee set to Jean-Philippe Lang

Files

0001-Fix-HTML-generated-for-floating-images-in-paragraphs.patch ~ 2.08 KB

firebug-output.png 17.4 KB
